diff --git a/sys/dev/raid/arcmsr/arcmsr.c b/sys/dev/raid/arcmsr/arcmsr.c
index f08380d..f0467c8 100644
--- a/sys/dev/raid/arcmsr/arcmsr.c
+++ b/sys/dev/raid/arcmsr/arcmsr.c
@@ -1366,12 +1603,20 @@ static void arcmsr_dr_handle(struct AdapterControlBlock *acb) {
 
 	case ACB_ADAPTER_TYPE_C:
 			devicemap = offsetof(struct HBC_MessageUnit, msgcode_rwbuffer[ARCMSR_FW_DEVMAP_OFFSET]);
-			for (target= 0; target < 4; target++)
+			for (target = 0; target < 4; target++) 
 			{
 		deviceMapCurrent[target]=bus_space_read_4(acb->btag[0], acb->bhandle[0],  devicemap);
 		devicemap += 4;
 			}
 			break;
+	case ACB_ADAPTER_TYPE_D:
+			devicemap = offsetof(struct HBD_MessageUnit, msgcode_rwbuffer[ARCMSR_FW_DEVMAP_OFFSET]);
+			for (target = 0; target < 4; target++) 
+			{
+            	deviceMapCurrent[target]=bus_space_read_4(acb->btag[0], acb->bhandle[0],  devicemap);
+            	devicemap += 4;
+			}
+			break;
 	}
 
 		if(acb->acb_flags & ACB_F_BUS_HANG_ON)
@@ -1383,16 +1628,16 @@ static void arcmsr_dr_handle(struct AdapterControlBlock *acb) {
 		** copy the new map, note if there are differences with the current map
 		*/
 		pDevMap = (u_int8_t	*)&deviceMapCurrent[0];
-		for (target= 0; target < ARCMSR_MAX_TARGETID - 1; target++)
+		for (target = 0; target < ARCMSR_MAX_TARGETID - 1; target++) 
 		{
 			if (*pDevMap != acb->device_map[target])
 			{
                 u_int8_t difference, bit_check;
 
-                difference= *pDevMap ^ acb->device_map[target];
+                difference = *pDevMap ^ acb->device_map[target];
                 for(lun=0; lun < ARCMSR_MAX_TARGETLUN; lun++)
                 {
-                    bit_check=(1 << lun);						/*check bit from 0....31*/
+                    bit_check = (1 << lun);						/*check bit from 0....31*/
                     if(difference & bit_check)
                     {
                         if(acb->device_map[target] & bit_check)
@@ -1411,7 +1656,7 @@ static void arcmsr_dr_handle(struct AdapterControlBlock *acb) {
                     }
                 }
 /*				kprintf("arcmsr_dr_handle: acb->device_map[%x]=0x%x, deviceMapCurrent[%x]=%x\n",target,acb->device_map[target],target,*pDevMap); */
-				acb->device_map[target]= *pDevMap;
+				acb->device_map[target] = *pDevMap;
 			}
 			pDevMap++;
 		}
@@ -1457,9 +1702,21 @@ static void arcmsr_hbc_message_isr(struct AdapterControlBlock *acb) {
 **************************************************************************
 **************************************************************************
 */
+static void arcmsr_hbd_message_isr(struct AdapterControlBlock *acb) {
+	u_int32_t outbound_message;
+
+	CHIP_REG_WRITE32(HBD_MessageUnit, 0, outbound_doorbell, ARCMSR_HBDMU_IOP2DRV_MESSAGE_CMD_DONE_CLEAR);
+	outbound_message = CHIP_REG_READ32(HBD_MessageUnit, 0, msgcode_rwbuffer[0]);
+	if (outbound_message == ARCMSR_SIGNATURE_GET_CONFIG)
+		arcmsr_dr_handle( acb );
+}
+/*
+**************************************************************************
+**************************************************************************
+*/
 static void arcmsr_hba_doorbell_isr(struct AdapterControlBlock *acb)
 {
-	u_int32_t outbound_doorbell;
+	u_int32_t doorbell_status;
 
 	/*
 	*******************************************************************
@@ -1468,14 +1725,12 @@ static void arcmsr_hba_doorbell_isr(struct AdapterControlBlock *acb)
 	**  check if there are any mail need to pack from firmware
 	*******************************************************************
 	*/
-	outbound_doorbell=CHIP_REG_READ32(HBA_MessageUnit,
-	0, outbound_doorbell);
-	CHIP_REG_WRITE32(HBA_MessageUnit,
-	0, outbound_doorbell, outbound_doorbell); /* clear doorbell interrupt */
-	if(outbound_doorbell & ARCMSR_OUTBOUND_IOP331_DATA_WRITE_OK) {
+	doorbell_status = CHIP_REG_READ32(HBA_MessageUnit, 0, outbound_doorbell);
+	CHIP_REG_WRITE32(HBA_MessageUnit, 0, outbound_doorbell, doorbell_status); /* clear doorbell interrupt */
+	if(doorbell_status & ARCMSR_OUTBOUND_IOP331_DATA_WRITE_OK) {
 		arcmsr_iop2drv_data_wrote_handle(acb);
 	}
-	if(outbound_doorbell & ARCMSR_OUTBOUND_IOP331_DATA_READ_OK) {
+	if(doorbell_status & ARCMSR_OUTBOUND_IOP331_DATA_READ_OK) {
 		arcmsr_iop2drv_data_read_handle(acb);
 	}
 }
@@ -1485,7 +1740,7 @@ static void arcmsr_hba_doorbell_isr(struct AdapterControlBlock *acb)
 */
 static void arcmsr_hbc_doorbell_isr(struct AdapterControlBlock *acb)
 {
-	u_int32_t outbound_doorbell;
+	u_int32_t doorbell_status;
 
 	/*
 	*******************************************************************
@@ -1494,15 +1749,15 @@ static void arcmsr_hbc_doorbell_isr(struct AdapterControlBlock *acb)
 	**  check if there are any mail need to pack from firmware
 	*******************************************************************
 	*/
-	outbound_doorbell=CHIP_REG_READ32(HBC_MessageUnit, 0, outbound_doorbell);
-	CHIP_REG_WRITE32(HBC_MessageUnit, 0, outbound_doorbell_clear, outbound_doorbell); /* clear doorbell interrupt */
-	if(outbound_doorbell & ARCMSR_HBCMU_IOP2DRV_DATA_WRITE_OK) {
+	doorbell_status = CHIP_REG_READ32(HBC_MessageUnit, 0, outbound_doorbell);
+	CHIP_REG_WRITE32(HBC_MessageUnit, 0, outbound_doorbell_clear, doorbell_status); /* clear doorbell interrupt */
+	if(doorbell_status & ARCMSR_HBCMU_IOP2DRV_DATA_WRITE_OK) {
 		arcmsr_iop2drv_data_wrote_handle(acb);
 	}
-	if(outbound_doorbell & ARCMSR_HBCMU_IOP2DRV_DATA_READ_OK) {
+	if(doorbell_status & ARCMSR_HBCMU_IOP2DRV_DATA_READ_OK) {
 		arcmsr_iop2drv_data_read_handle(acb);
 	}
-	if(outbound_doorbell & ARCMSR_HBCMU_IOP2DRV_MESSAGE_CMD_DONE) {
+	if(doorbell_status & ARCMSR_HBCMU_IOP2DRV_MESSAGE_CMD_DONE) {
 		arcmsr_hbc_message_isr(acb);    /* messenger of "driver to iop commands" */
 	}
 }
@@ -1510,6 +1765,39 @@ static void arcmsr_hbc_doorbell_isr(struct AdapterControlBlock *acb)
 **************************************************************************
 **************************************************************************
 */
+static void arcmsr_hbd_doorbell_isr(struct AdapterControlBlock *acb)
+{
+	u_int32_t doorbell_status;
+	
+	/*
+	*******************************************************************
+	**  Maybe here we need to check wrqbuffer_lock is lock or not
+	**  DOORBELL: din! don! 
+	**  check if there are any mail need to pack from firmware
+	*******************************************************************
+	*/
+	doorbell_status = CHIP_REG_READ32(HBD_MessageUnit, 0, outbound_doorbell) & ARCMSR_HBDMU_F0_DOORBELL_CAUSE;
+	if(doorbell_status)
+		CHIP_REG_WRITE32(HBD_MessageUnit, 0, outbound_doorbell, doorbell_status); /* clear doorbell interrupt */
+	while( doorbell_status & ARCMSR_HBDMU_F0_DOORBELL_CAUSE ) {
+		if(doorbell_status & ARCMSR_HBDMU_IOP2DRV_DATA_WRITE_OK) {
+			arcmsr_iop2drv_data_wrote_handle(acb);
+		}
+		if(doorbell_status & ARCMSR_HBDMU_IOP2DRV_DATA_READ_OK) {
+			arcmsr_iop2drv_data_read_handle(acb);
+		}
+		if(doorbell_status & ARCMSR_HBDMU_IOP2DRV_MESSAGE_CMD_DONE) {
+			arcmsr_hbd_message_isr(acb);    /* messenger of "driver to iop commands" */
+		}
+		doorbell_status = CHIP_REG_READ32(HBD_MessageUnit, 0, outbound_doorbell) & ARCMSR_HBDMU_F0_DOORBELL_CAUSE;
+		if(doorbell_status)
+			CHIP_REG_WRITE32(HBD_MessageUnit, 0, outbound_doorbell, doorbell_status); /* clear doorbell interrupt */
+	}
+}
+/*
+**************************************************************************
+**************************************************************************
+*/
 static void arcmsr_hba_postqueue_isr(struct AdapterControlBlock *acb)
 {
 	u_int32_t flag_srb;
@@ -1522,10 +1810,10 @@ static void arcmsr_hba_postqueue_isr(struct AdapterControlBlock *acb)
 	*/
 	bus_dmamap_sync(acb->srb_dmat, acb->srb_dmamap,
 		BUS_DMASYNC_POSTREAD|BUS_DMASYNC_POSTWRITE);
-	while((flag_srb=CHIP_REG_READ32(HBA_MessageUnit,
+	while((flag_srb = CHIP_REG_READ32(HBA_MessageUnit, 
 		0, outbound_queueport)) != 0xFFFFFFFF) {
 		/* check if command done with no error*/
-        error=(flag_srb & ARCMSR_SRBREPLY_FLAG_ERROR_MODE0)?TRUE:FALSE;
+        error = (flag_srb & ARCMSR_SRBREPLY_FLAG_ERROR_MODE0) ? TRUE : FALSE;
 		arcmsr_drain_donequeue(acb, flag_srb, error);
 	}	/*drain reply FIFO*/
 }
@@ -1535,7 +1823,7 @@ static void arcmsr_hba_postqueue_isr(struct AdapterControlBlock *acb)
 */
 static void arcmsr_hbb_postqueue_isr(struct AdapterControlBlock *acb)
 {
-	struct HBB_MessageUnit *phbbmu=(struct HBB_MessageUnit *)acb->pmu;
+	struct HBB_MessageUnit *phbbmu = (struct HBB_MessageUnit *)acb->pmu;
 	u_int32_t flag_srb;
 	int index;
 	u_int16_t error;
@@ -1547,14 +1835,14 @@ static void arcmsr_hbb_postqueue_isr(struct AdapterControlBlock *acb)
 	*/
 	bus_dmamap_sync(acb->srb_dmat, acb->srb_dmamap,
 		BUS_DMASYNC_POSTREAD|BUS_DMASYNC_POSTWRITE);
-	index=phbbmu->doneq_index;
-	while((flag_srb=phbbmu->done_qbuffer[index]) != 0) {
-		phbbmu->done_qbuffer[index]=0;
+	index = phbbmu->doneq_index;
+	while((flag_srb = phbbmu->done_qbuffer[index]) != 0) {
+		phbbmu->done_qbuffer[index] = 0;
 		index++;
 		index %= ARCMSR_MAX_HBB_POSTQUEUE;     /*if last index number set it to 0 */
-		phbbmu->doneq_index=index;
+		phbbmu->doneq_index = index;
 		/* check if command done with no error*/
-        error=(flag_srb & ARCMSR_SRBREPLY_FLAG_ERROR_MODE0)?TRUE:FALSE;
+        error = (flag_srb & ARCMSR_SRBREPLY_FLAG_ERROR_MODE0)?TRUE:FALSE;
 		arcmsr_drain_donequeue(acb, flag_srb, error);
 	}	/*drain reply FIFO*/
 }
@@ -1564,7 +1852,7 @@ static void arcmsr_hbb_postqueue_isr(struct AdapterControlBlock *acb)
 */
 static void arcmsr_hbc_postqueue_isr(struct AdapterControlBlock *acb)
 {
-	u_int32_t flag_srb,throttling=0;
+	u_int32_t flag_srb,throttling = 0;
 	u_int16_t error;
 
 	/*
@@ -1573,19 +1861,76 @@ static void arcmsr_hbc_postqueue_isr(struct AdapterControlBlock *acb)
 	*****************************************************************************
 	*/
 	bus_dmamap_sync(acb->srb_dmat, acb->srb_dmamap, BUS_DMASYNC_POSTREAD|BUS_DMASYNC_POSTWRITE);
-
-	while(CHIP_REG_READ32(HBC_MessageUnit, 0, host_int_status) & ARCMSR_HBCMU_OUTBOUND_POSTQUEUE_ISR) {
-
-		flag_srb=CHIP_REG_READ32(HBC_MessageUnit, 0, outbound_queueport_low);
+	do {
+		flag_srb = CHIP_REG_READ32(HBC_MessageUnit, 0, outbound_queueport_low);
 		/* check if command done with no error*/
-        error=(flag_srb & ARCMSR_SRBREPLY_FLAG_ERROR_MODE1)?TRUE:FALSE;
+        	error = (flag_srb & ARCMSR_SRBREPLY_FLAG_ERROR_MODE1)?TRUE:FALSE;
 		arcmsr_drain_donequeue(acb, flag_srb, error);
-        if(throttling==ARCMSR_HBC_ISR_THROTTLING_LEVEL) {
-            CHIP_REG_WRITE32(HBC_MessageUnit, 0, inbound_doorbell,ARCMSR_HBCMU_DRV2IOP_POSTQUEUE_THROTTLING);
-            break;
-        }
-        throttling++;
-	}	/*drain reply FIFO*/
+        	throttling++;
+		if(throttling == ARCMSR_HBC_ISR_THROTTLING_LEVEL) {
+			CHIP_REG_WRITE32(HBC_MessageUnit, 0, inbound_doorbell,ARCMSR_HBCMU_DRV2IOP_POSTQUEUE_THROTTLING);
+			throttling = 0;
+        	}
+	} while(CHIP_REG_READ32(HBC_MessageUnit, 0, host_int_status) & ARCMSR_HBCMU_OUTBOUND_POSTQUEUE_ISR);
+}
+/*
+**********************************************************************
+** 
+**********************************************************************
+*/
+static uint16_t arcmsr_get_doneq_index(struct HBD_MessageUnit0 *phbdmu)
+{
+	uint16_t doneq_index, index_stripped;
+
+	doneq_index = phbdmu->doneq_index;
+	if (doneq_index & 0x4000) {
+		index_stripped = doneq_index & 0xFF;
+		index_stripped += 1;
+		index_stripped %= ARCMSR_MAX_HBD_POSTQUEUE;
+		phbdmu->doneq_index = index_stripped ?
+		    (index_stripped | 0x4000) : index_stripped;
+	} else {
+		index_stripped = doneq_index;
+		index_stripped += 1;
+		index_stripped %= ARCMSR_MAX_HBD_POSTQUEUE;
+		phbdmu->doneq_index = index_stripped ?
+		    index_stripped : (index_stripped | 0x4000);
+	}
+	return (phbdmu->doneq_index);
+}
+/*
+**************************************************************************
+**************************************************************************
+*/
+static void arcmsr_hbd_postqueue_isr(struct AdapterControlBlock *acb)
+{
+	struct HBD_MessageUnit0 *phbdmu = (struct HBD_MessageUnit0 *)acb->pmu;
+	u_int32_t outbound_write_pointer;
+	u_int32_t addressLow;
+	uint16_t doneq_index;
+	u_int16_t error;
+	/*
+	*****************************************************************************
+	**               areca cdb command done
+	*****************************************************************************
+	*/
+	if((CHIP_REG_READ32(HBD_MessageUnit, 0, outboundlist_interrupt_cause) &
+	    ARCMSR_HBDMU_OUTBOUND_LIST_INTERRUPT) == 0)
+	    return;
+	bus_dmamap_sync(acb->srb_dmat, acb->srb_dmamap, 
+		BUS_DMASYNC_POSTREAD | BUS_DMASYNC_POSTWRITE);
+	outbound_write_pointer = phbdmu->done_qbuffer[0].addressLow;
+	doneq_index = phbdmu->doneq_index;
+	while ((doneq_index & 0xFF) != (outbound_write_pointer & 0xFF)) {
+		doneq_index = arcmsr_get_doneq_index(phbdmu);
+		addressLow = phbdmu->done_qbuffer[(doneq_index & 0xFF)+1].addressLow;
+		error = (addressLow & ARCMSR_SRBREPLY_FLAG_ERROR_MODE1) ? TRUE : FALSE;
+		arcmsr_drain_donequeue(acb, addressLow, error); /*Check if command done with no error */
+		CHIP_REG_WRITE32(HBD_MessageUnit, 0, outboundlist_read_pointer, doneq_index);
+		outbound_write_pointer = phbdmu->done_qbuffer[0].addressLow;
+	}
+	CHIP_REG_WRITE32(HBD_MessageUnit, 0, outboundlist_interrupt_cause, ARCMSR_HBDMU_OUTBOUND_LIST_INTERRUPT_CLEAR);
+	CHIP_REG_READ32(HBD_MessageUnit, 0, outboundlist_interrupt_cause); /*Dummy ioread32 to force pci flush */
 }
 /*
 **********************************************************************
@@ -1599,12 +1944,12 @@ static void arcmsr_handle_hba_isr( struct AdapterControlBlock *acb)
 	**   check outbound intstatus
 	*********************************************
 	*/
-	outbound_intStatus=CHIP_REG_READ32(HBA_MessageUnit, 0, outbound_intstatus) & acb->outbound_int_enable;
+	outbound_intStatus = CHIP_REG_READ32(HBA_MessageUnit, 0, outbound_intstatus) & acb->outbound_int_enable;
 	if(!outbound_intStatus) {
 		/*it must be share irq*/
 		return;
 	}
-	CHIP_REG_WRITE32(HBA_MessageUnit, 0, outbound_intstatus, outbound_intStatus);/*clear interrupt*/
+	CHIP_REG_WRITE32(HBA_MessageUnit, 0, outbound_intstatus, outbound_intStatus); /*clear interrupt*/
 	/* MU doorbell interrupts*/
 	if(outbound_intStatus & ARCMSR_MU_OUTBOUND_DOORBELL_INT) {
 		arcmsr_hba_doorbell_isr(acb);
@@ -1629,7 +1974,7 @@ static void arcmsr_handle_hbb_isr( struct AdapterControlBlock *acb)
 	**   check outbound intstatus
 	*********************************************
 	*/
-	outbound_doorbell=CHIP_REG_READ32(HBB_DOORBELL, 0, iop2drv_doorbell) & acb->outbound_int_enable;
+	outbound_doorbell = CHIP_REG_READ32(HBB_DOORBELL, 0, iop2drv_doorbell) & acb->outbound_int_enable;
 	if(!outbound_doorbell) {
 		/*it must be share irq*/
 		return;
@@ -1664,19 +2009,57 @@ static void arcmsr_handle_hbc_isr( struct AdapterControlBlock *acb)
 	**   check outbound intstatus
 	*********************************************
 	*/
-	host_interrupt_status=CHIP_REG_READ32(HBC_MessageUnit, 0, host_int_status);
+	host_interrupt_status = CHIP_REG_READ32(HBC_MessageUnit, 0, host_int_status) &
+		(ARCMSR_HBCMU_OUTBOUND_POSTQUEUE_ISR |
+		ARCMSR_HBCMU_OUTBOUND_DOORBELL_ISR);
 	if(!host_interrupt_status) {
 		/*it must be share irq*/
 		return;
 	}
+	do {
+		/* MU doorbell interrupts*/
+		if(host_interrupt_status & ARCMSR_HBCMU_OUTBOUND_DOORBELL_ISR) {
+			arcmsr_hbc_doorbell_isr(acb);
+		}
+		/* MU post queue interrupts*/
+		if(host_interrupt_status & ARCMSR_HBCMU_OUTBOUND_POSTQUEUE_ISR) {
+			arcmsr_hbc_postqueue_isr(acb);
+		}
+		host_interrupt_status = CHIP_REG_READ32(HBC_MessageUnit, 0, host_int_status);
+	} while (host_interrupt_status & (ARCMSR_HBCMU_OUTBOUND_POSTQUEUE_ISR | ARCMSR_HBCMU_OUTBOUND_DOORBELL_ISR));
+}
+/*
+**********************************************************************
+**********************************************************************
+*/
+static void arcmsr_handle_hbd_isr( struct AdapterControlBlock *acb)
+{
+	u_int32_t host_interrupt_status;
+	u_int32_t intmask_org;
+	/*
+	*********************************************
+	**   check outbound intstatus 
+	*********************************************
+	*/
+	host_interrupt_status = CHIP_REG_READ32(HBD_MessageUnit, 0, host_int_status) & acb->outbound_int_enable;
+	if(!(host_interrupt_status & ARCMSR_HBDMU_OUTBOUND_INT)) {
+		/*it must be share irq*/
+		return;
+	}
+	/* disable outbound interrupt */
+	intmask_org = CHIP_REG_READ32(HBD_MessageUnit, 0, pcief0_int_enable)	; /* disable outbound message0 int */
+	CHIP_REG_WRITE32(HBD_MessageUnit, 0, pcief0_int_enable, ARCMSR_HBDMU_ALL_INT_DISABLE);
 	/* MU doorbell interrupts*/
-	if(host_interrupt_status & ARCMSR_HBCMU_OUTBOUND_DOORBELL_ISR) {
-		arcmsr_hbc_doorbell_isr(acb);
+	if(host_interrupt_status & ARCMSR_HBDMU_OUTBOUND_DOORBELL_INT) {
+		arcmsr_hbd_doorbell_isr(acb);
 	}
 	/* MU post queue interrupts*/
-	if(host_interrupt_status & ARCMSR_HBCMU_OUTBOUND_POSTQUEUE_ISR) {
-		arcmsr_hbc_postqueue_isr(acb);
+	if(host_interrupt_status & ARCMSR_HBDMU_OUTBOUND_POSTQUEUE_INT) {
+		arcmsr_hbd_postqueue_isr(acb);
 	}
+	/* enable all outbound interrupt */
+	CHIP_REG_WRITE32(HBD_MessageUnit, 0, pcief0_int_enable, intmask_org | ARCMSR_HBDMU_ALL_INT_ENABLE);
+//	CHIP_REG_READ32(HBD_MessageUnit, 0, pcief0_int_enable);
 }
 /*
 ******************************************************************************
@@ -1694,6 +2077,9 @@ static void arcmsr_interrupt(struct AdapterControlBlock *acb)
 	case ACB_ADAPTER_TYPE_C:
 		arcmsr_handle_hbc_isr(acb);
 		break;
+	case ACB_ADAPTER_TYPE_D:
+		arcmsr_handle_hbd_isr(acb);
+		break;
 	default:
 		kprintf("arcmsr%d: interrupt service,"
 		" unknown adapter type =%d\n", acb->pci_unit, acb->adapter_type);
@@ -1706,17 +2092,17 @@ static void arcmsr_interrupt(struct AdapterControlBlock *acb)
 */
 static void arcmsr_intr_handler(void *arg)
 {
-	struct AdapterControlBlock *acb=(struct AdapterControlBlock *)arg;
+	struct AdapterControlBlock *acb = (struct AdapterControlBlock *)arg;
 
-	ARCMSR_LOCK_ACQUIRE(&acb->qbuffer_lock);
+	ARCMSR_LOCK_ACQUIRE(&acb->isr_lock);
 	arcmsr_interrupt(acb);
-	ARCMSR_LOCK_RELEASE(&acb->qbuffer_lock);
+	ARCMSR_LOCK_RELEASE(&acb->isr_lock);
 }
 /*
 ******************************************************************************
 ******************************************************************************
 */
-static void	arcmsr_polling_devmap(void* arg)
+static void	arcmsr_polling_devmap(void *arg)
 {
 	struct AdapterControlBlock *acb = (struct AdapterControlBlock *)arg;
 	switch (acb->adapter_type) {
@@ -1732,6 +2118,10 @@ static void	arcmsr_polling_devmap(void* arg)
 			CHIP_REG_WRITE32(HBC_MessageUnit, 0, inbound_msgaddr0, ARCMSR_INBOUND_MESG0_GET_CONFIG);
 			CHIP_REG_WRITE32(HBC_MessageUnit, 0, inbound_doorbell, ARCMSR_HBCMU_DRV2IOP_MESSAGE_CMD_DONE);
 		break;
+
+    	case ACB_ADAPTER_TYPE_D:
+			CHIP_REG_WRITE32(HBD_MessageUnit, 0, inbound_msgaddr0, ARCMSR_INBOUND_MESG0_GET_CONFIG);
+	    	break;
 	}
 
 	if((acb->acb_flags & ACB_F_SCSISTOPADAPTER) == 0)
@@ -1749,7 +2139,7 @@ static void arcmsr_iop_parking(struct AdapterControlBlock *acb)
 {
 	u_int32_t intmask_org;
 
-	if(acb!=NULL) {
+	if(acb != NULL) {
 		/* stop adapter background rebuild */
 		if(acb->acb_flags & ACB_F_MSG_START_BGRB) {
 			intmask_org = arcmsr_disable_allintr(acb);
@@ -1766,25 +2156,25 @@ static void arcmsr_iop_parking(struct AdapterControlBlock *acb)
 */
 u_int32_t arcmsr_iop_ioctlcmd(struct AdapterControlBlock *acb, u_int32_t ioctl_cmd, caddr_t arg)
 {
-	struct CMD_MESSAGE_FIELD * pcmdmessagefld;
-	u_int32_t retvalue=EINVAL;
+	struct CMD_MESSAGE_FIELD *pcmdmessagefld;
+	u_int32_t retvalue = EINVAL;
 
-	pcmdmessagefld=(struct CMD_MESSAGE_FIELD *) arg;
+	pcmdmessagefld = (struct CMD_MESSAGE_FIELD *) arg;
 	if(memcmp(pcmdmessagefld->cmdmessage.Signature, "ARCMSR", 6)!=0) {
 		return retvalue;
 	}
 	ARCMSR_LOCK_ACQUIRE(&acb->qbuffer_lock);
 	switch(ioctl_cmd) {
 	case ARCMSR_MESSAGE_READ_RQBUFFER: {
-			u_int8_t * pQbuffer;
-			u_int8_t * ptmpQbuffer=pcmdmessagefld->messagedatabuffer;
+			u_int8_t *pQbuffer;
+			u_int8_t *ptmpQbuffer = pcmdmessagefld->messagedatabuffer;			
 			u_int32_t allxfer_len=0;
 
-			while((acb->rqbuf_firstindex!=acb->rqbuf_lastindex)
-				&& (allxfer_len<1031)) {
+			while((acb->rqbuf_firstindex != acb->rqbuf_lastindex) 
+				&& (allxfer_len < 1031)) {
 				/*copy READ QBUFFER to srb*/
-				pQbuffer= &acb->rqbuffer[acb->rqbuf_firstindex];
-				memcpy(ptmpQbuffer, pQbuffer, 1);
+				pQbuffer = &acb->rqbuffer[acb->rqbuf_firstindex];
+				*ptmpQbuffer = *pQbuffer;
 				acb->rqbuf_firstindex++;
 				acb->rqbuf_firstindex %= ARCMSR_MAX_QBUFFER;
 				/*if last index number set it to 0 */
@@ -1792,51 +2182,38 @@ u_int32_t arcmsr_iop_ioctlcmd(struct AdapterControlBlock *acb, u_int32_t ioctl_c
 				allxfer_len++;
 			}
 			if(acb->acb_flags & ACB_F_IOPDATA_OVERFLOW) {
-				struct QBUFFER * prbuffer;
-				u_int8_t * iop_data;
-				u_int32_t iop_len;
+				struct QBUFFER *prbuffer;
 
 				acb->acb_flags &= ~ACB_F_IOPDATA_OVERFLOW;
-				prbuffer=arcmsr_get_iop_rqbuffer(acb);
-				iop_data=(u_int8_t *)prbuffer->data;
-				iop_len=(u_int32_t)prbuffer->data_len;
-				/*this iop data does no chance to make me overflow again here, so just do it*/
-				while(iop_len>0) {
-					pQbuffer= &acb->rqbuffer[acb->rqbuf_lastindex];
-					memcpy(pQbuffer, iop_data, 1);
-					acb->rqbuf_lastindex++;
-					acb->rqbuf_lastindex %= ARCMSR_MAX_QBUFFER;
-					/*if last index number set it to 0 */
-					iop_data++;
-					iop_len--;
-				}
-				arcmsr_iop_message_read(acb);
-				/*signature, let IOP know data has been readed */
+				prbuffer = arcmsr_get_iop_rqbuffer(acb);
+				if(arcmsr_Read_iop_rqbuffer_data(acb, prbuffer) == 0)
+					acb->acb_flags |= ACB_F_IOPDATA_OVERFLOW;
 			}
-			pcmdmessagefld->cmdmessage.Length=allxfer_len;
-			pcmdmessagefld->cmdmessage.ReturnCode=ARCMSR_MESSAGE_RETURNCODE_OK;
-			retvalue=ARCMSR_MESSAGE_SUCCESS;
+			pcmdmessagefld->cmdmessage.Length = allxfer_len;
+			pcmdmessagefld->cmdmessage.ReturnCode = ARCMSR_MESSAGE_RETURNCODE_OK;
+			retvalue = ARCMSR_MESSAGE_SUCCESS;
 		}
 		break;
 	case ARCMSR_MESSAGE_WRITE_WQBUFFER: {
 			u_int32_t my_empty_len, user_len, wqbuf_firstindex, wqbuf_lastindex;
-			u_int8_t * pQbuffer;
-			u_int8_t * ptmpuserbuffer=pcmdmessagefld->messagedatabuffer;
+			u_int8_t *pQbuffer;
+			u_int8_t *ptmpuserbuffer = pcmdmessagefld->messagedatabuffer;
 
-			user_len=pcmdmessagefld->cmdmessage.Length;
+			user_len = pcmdmessagefld->cmdmessage.Length;
 			/*check if data xfer length of this request will overflow my array qbuffer */
-			wqbuf_lastindex=acb->wqbuf_lastindex;
-			wqbuf_firstindex=acb->wqbuf_firstindex;
-			if(wqbuf_lastindex!=wqbuf_firstindex) {
-				arcmsr_post_ioctldata2iop(acb);
-				pcmdmessagefld->cmdmessage.ReturnCode=ARCMSR_MESSAGE_RETURNCODE_ERROR;
+			wqbuf_lastindex = acb->wqbuf_lastindex;
+			wqbuf_firstindex = acb->wqbuf_firstindex;
+			if(wqbuf_lastindex != wqbuf_firstindex) {
+				arcmsr_Write_data_2iop_wqbuffer(acb);
+				pcmdmessagefld->cmdmessage.ReturnCode = ARCMSR_MESSAGE_RETURNCODE_ERROR;
 			} else {
-				my_empty_len=(wqbuf_firstindex-wqbuf_lastindex-1)&(ARCMSR_MAX_QBUFFER-1);
-				if(my_empty_len>=user_len) {
-					while(user_len>0) {
+				my_empty_len = (wqbuf_firstindex - wqbuf_lastindex - 1) &
+				    (ARCMSR_MAX_QBUFFER - 1);
+				if(my_empty_len >= user_len) {
+					while(user_len > 0) {
 						/*copy srb data to wqbuffer*/
-						pQbuffer= &acb->wqbuffer[acb->wqbuf_lastindex];
-						memcpy(pQbuffer, ptmpuserbuffer, 1);
+						pQbuffer = &acb->wqbuffer[acb->wqbuf_lastindex];
+						*pQbuffer = *ptmpuserbuffer;
 						acb->wqbuf_lastindex++;
 						acb->wqbuf_lastindex %= ARCMSR_MAX_QBUFFER;
 						/*if last index number set it to 0 */
@@ -1845,19 +2222,19 @@ u_int32_t arcmsr_iop_ioctlcmd(struct AdapterControlBlock *acb, u_int32_t ioctl_c
 					}
 					/*post fist Qbuffer*/
 					if(acb->acb_flags & ACB_F_MESSAGE_WQBUFFER_CLEARED) {
-						acb->acb_flags &=~ACB_F_MESSAGE_WQBUFFER_CLEARED;
-						arcmsr_post_ioctldata2iop(acb);
+						acb->acb_flags &= ~ACB_F_MESSAGE_WQBUFFER_CLEARED;
+						arcmsr_Write_data_2iop_wqbuffer(acb);
 					}
-					pcmdmessagefld->cmdmessage.ReturnCode=ARCMSR_MESSAGE_RETURNCODE_OK;
+					pcmdmessagefld->cmdmessage.ReturnCode = ARCMSR_MESSAGE_RETURNCODE_OK;
 				} else {
-					pcmdmessagefld->cmdmessage.ReturnCode=ARCMSR_MESSAGE_RETURNCODE_ERROR;
+					pcmdmessagefld->cmdmessage.ReturnCode = ARCMSR_MESSAGE_RETURNCODE_ERROR;
 				}
 			}
-			retvalue=ARCMSR_MESSAGE_SUCCESS;
+			retvalue = ARCMSR_MESSAGE_SUCCESS;
 		}
 		break;
 	case ARCMSR_MESSAGE_CLEAR_RQBUFFER: {
-			u_int8_t * pQbuffer=acb->rqbuffer;
+			u_int8_t *pQbuffer = acb->rqbuffer;
 
 			if(acb->acb_flags & ACB_F_IOPDATA_OVERFLOW) {
 				acb->acb_flags &= ~ACB_F_IOPDATA_OVERFLOW;
@@ -1865,16 +2242,16 @@ u_int32_t arcmsr_iop_ioctlcmd(struct AdapterControlBlock *acb, u_int32_t ioctl_c
 				/*signature, let IOP know data has been readed */
 			}
 			acb->acb_flags |= ACB_F_MESSAGE_RQBUFFER_CLEARED;
-			acb->rqbuf_firstindex=0;
-			acb->rqbuf_lastindex=0;
+			acb->rqbuf_firstindex = 0;
+			acb->rqbuf_lastindex = 0;
 			memset(pQbuffer, 0, ARCMSR_MAX_QBUFFER);
-			pcmdmessagefld->cmdmessage.ReturnCode=ARCMSR_MESSAGE_RETURNCODE_OK;
-			retvalue=ARCMSR_MESSAGE_SUCCESS;
+			pcmdmessagefld->cmdmessage.ReturnCode = ARCMSR_MESSAGE_RETURNCODE_OK;
+			retvalue = ARCMSR_MESSAGE_SUCCESS;
 		}
 		break;
 	case ARCMSR_MESSAGE_CLEAR_WQBUFFER:
 		{
-			u_int8_t * pQbuffer=acb->wqbuffer;
+			u_int8_t *pQbuffer = acb->wqbuffer;
 
 			if(acb->acb_flags & ACB_F_IOPDATA_OVERFLOW) {
 				acb->acb_flags &= ~ACB_F_IOPDATA_OVERFLOW;
@@ -1882,15 +2259,15 @@ u_int32_t arcmsr_iop_ioctlcmd(struct AdapterControlBlock *acb, u_int32_t ioctl_c
 				/*signature, let IOP know data has been readed */
 			}
 			acb->acb_flags |= (ACB_F_MESSAGE_WQBUFFER_CLEARED|ACB_F_MESSAGE_WQBUFFER_READ);
-			acb->wqbuf_firstindex=0;
-			acb->wqbuf_lastindex=0;
+			acb->wqbuf_firstindex = 0;
+			acb->wqbuf_lastindex = 0;
 			memset(pQbuffer, 0, ARCMSR_MAX_QBUFFER);
-			pcmdmessagefld->cmdmessage.ReturnCode=ARCMSR_MESSAGE_RETURNCODE_OK;
-			retvalue=ARCMSR_MESSAGE_SUCCESS;
+			pcmdmessagefld->cmdmessage.ReturnCode = ARCMSR_MESSAGE_RETURNCODE_OK;
+			retvalue = ARCMSR_MESSAGE_SUCCESS;
 		}
 		break;
 	case ARCMSR_MESSAGE_CLEAR_ALLQBUFFER: {
-			u_int8_t * pQbuffer;
+			u_int8_t *pQbuffer;
 
 			if(acb->acb_flags & ACB_F_IOPDATA_OVERFLOW) {
 				acb->acb_flags &= ~ACB_F_IOPDATA_OVERFLOW;
@@ -1900,44 +2277,44 @@ u_int32_t arcmsr_iop_ioctlcmd(struct AdapterControlBlock *acb, u_int32_t ioctl_c
 			acb->acb_flags  |= (ACB_F_MESSAGE_WQBUFFER_CLEARED
 					|ACB_F_MESSAGE_RQBUFFER_CLEARED
 					|ACB_F_MESSAGE_WQBUFFER_READ);
-			acb->rqbuf_firstindex=0;
-			acb->rqbuf_lastindex=0;
-			acb->wqbuf_firstindex=0;
-			acb->wqbuf_lastindex=0;
-			pQbuffer=acb->rqbuffer;
+			acb->rqbuf_firstindex = 0;
+			acb->rqbuf_lastindex = 0;
+			acb->wqbuf_firstindex = 0;
+			acb->wqbuf_lastindex = 0;
+			pQbuffer = acb->rqbuffer;
 			memset(pQbuffer, 0, sizeof(struct QBUFFER));
-			pQbuffer=acb->wqbuffer;
+			pQbuffer = acb->wqbuffer;
 			memset(pQbuffer, 0, sizeof(struct QBUFFER));
-			pcmdmessagefld->cmdmessage.ReturnCode=ARCMSR_MESSAGE_RETURNCODE_OK;
-			retvalue=ARCMSR_MESSAGE_SUCCESS;
+			pcmdmessagefld->cmdmessage.ReturnCode = ARCMSR_MESSAGE_RETURNCODE_OK;
+			retvalue = ARCMSR_MESSAGE_SUCCESS;
 		}
 		break;
 	case ARCMSR_MESSAGE_REQUEST_RETURNCODE_3F: {
-			pcmdmessagefld->cmdmessage.ReturnCode=ARCMSR_MESSAGE_RETURNCODE_3F;
-			retvalue=ARCMSR_MESSAGE_SUCCESS;
+			pcmdmessagefld->cmdmessage.ReturnCode = ARCMSR_MESSAGE_RETURNCODE_3F;
+			retvalue = ARCMSR_MESSAGE_SUCCESS;
 		}
 		break;
 	case ARCMSR_MESSAGE_SAY_HELLO: {
-			u_int8_t * hello_string="Hello! I am ARCMSR";
-			u_int8_t * puserbuffer=(u_int8_t *)pcmdmessagefld->messagedatabuffer;
+			u_int8_t *hello_string = "Hello! I am ARCMSR";
+			u_int8_t *puserbuffer = (u_int8_t *)pcmdmessagefld->messagedatabuffer;
 
 			if(memcpy(puserbuffer, hello_string, (int16_t)strlen(hello_string))) {
-				pcmdmessagefld->cmdmessage.ReturnCode=ARCMSR_MESSAGE_RETURNCODE_ERROR;
+				pcmdmessagefld->cmdmessage.ReturnCode = ARCMSR_MESSAGE_RETURNCODE_ERROR;
 				ARCMSR_LOCK_RELEASE(&acb->qbuffer_lock);
 				return ENOIOCTL;
 			}
-			pcmdmessagefld->cmdmessage.ReturnCode=ARCMSR_MESSAGE_RETURNCODE_OK;
-			retvalue=ARCMSR_MESSAGE_SUCCESS;
+			pcmdmessagefld->cmdmessage.ReturnCode = ARCMSR_MESSAGE_RETURNCODE_OK;
+			retvalue = ARCMSR_MESSAGE_SUCCESS;
 		}
 		break;
 	case ARCMSR_MESSAGE_SAY_GOODBYE: {
 			arcmsr_iop_parking(acb);
-			retvalue=ARCMSR_MESSAGE_SUCCESS;
+			retvalue = ARCMSR_MESSAGE_SUCCESS;
 		}
 		break;
 	case ARCMSR_MESSAGE_FLUSH_ADAPTER_CACHE: {
 			arcmsr_flush_adapter_cache(acb);
-			retvalue=ARCMSR_MESSAGE_SUCCESS;
+			retvalue = ARCMSR_MESSAGE_SUCCESS;
 		}
 		break;
 	}
@@ -1951,54 +2328,46 @@ u_int32_t arcmsr_iop_ioctlcmd(struct AdapterControlBlock *acb, u_int32_t ioctl_c
 static void arcmsr_free_srb(struct CommandControlBlock *srb)
 {
 	struct AdapterControlBlock	*acb;
-	int	mutex;
 
 	acb = srb->acb;
-	mutex = lockstatus(&acb->qbuffer_lock, curthread);
-	if( mutex == 0 )
-		ARCMSR_LOCK_ACQUIRE(&acb->qbuffer_lock);
-	srb->srb_state=ARCMSR_SRB_DONE;
-	srb->srb_flags=0;
-	acb->srbworkingQ[acb->workingsrb_doneindex]=srb;
+	ARCMSR_LOCK_ACQUIRE(&acb->srb_lock);
+	srb->srb_state = ARCMSR_SRB_DONE;
+	srb->srb_flags = 0;
+	acb->srbworkingQ[acb->workingsrb_doneindex] = srb;
 	acb->workingsrb_doneindex++;
 	acb->workingsrb_doneindex %= ARCMSR_MAX_FREESRB_NUM;
-	if( mutex == 0 )
-		ARCMSR_LOCK_RELEASE(&acb->qbuffer_lock);
+	ARCMSR_LOCK_RELEASE(&acb->srb_lock);
 }
 /*
 **************************************************************************
 **************************************************************************
 */
-struct CommandControlBlock * arcmsr_get_freesrb(struct AdapterControlBlock *acb)
+struct CommandControlBlock *arcmsr_get_freesrb(struct AdapterControlBlock *acb)
 {
-	struct CommandControlBlock *srb=NULL;
+	struct CommandControlBlock *srb = NULL;
 	u_int32_t workingsrb_startindex, workingsrb_doneindex;
-	int	mutex;
 
-	mutex = lockstatus(&acb->qbuffer_lock, curthread);
-	if( mutex == 0 )
-		ARCMSR_LOCK_ACQUIRE(&acb->qbuffer_lock);
-	workingsrb_doneindex=acb->workingsrb_doneindex;
-	workingsrb_startindex=acb->workingsrb_startindex;
-	srb=acb->srbworkingQ[workingsrb_startindex];
+	ARCMSR_LOCK_ACQUIRE(&acb->srb_lock);
+	workingsrb_doneindex = acb->workingsrb_doneindex;
+	workingsrb_startindex = acb->workingsrb_startindex;
+	srb = acb->srbworkingQ[workingsrb_startindex];
 	workingsrb_startindex++;
 	workingsrb_startindex %= ARCMSR_MAX_FREESRB_NUM;
-	if(workingsrb_doneindex!=workingsrb_startindex) {
-		acb->workingsrb_startindex=workingsrb_startindex;
+	if(workingsrb_doneindex != workingsrb_startindex) {
+		acb->workingsrb_startindex = workingsrb_startindex;
 	} else {
-		srb=NULL;
+		srb = NULL;
 	}
-	if( mutex == 0 )
-		ARCMSR_LOCK_RELEASE(&acb->qbuffer_lock);
+	ARCMSR_LOCK_RELEASE(&acb->srb_lock);
 	return(srb);
 }
 /*
 **************************************************************************
 **************************************************************************
 */
-static int arcmsr_iop_message_xfer(struct AdapterControlBlock *acb, union ccb * pccb)
+static int arcmsr_iop_message_xfer(struct AdapterControlBlock *acb, union ccb *pccb)
 {
-	struct CMD_MESSAGE_FIELD * pcmdmessagefld;
+	struct CMD_MESSAGE_FIELD *pcmdmessagefld;
 	int retvalue = 0, transfer_len = 0;
 	char *buffer;
 	u_int32_t controlcode = (u_int32_t ) pccb->csio.cdb_io.cdb_bytes[5] << 24 |
